#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_ADXL345_U.h>

const int trigPin = 3;
const int echoPin = 4;
const int buzzerPin = 8;

Adafruit_ADXL345_Unified accel = Adafruit_ADXL345_Unified(12345);

void setup() {
  Serial.begin(9600);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);
  pinMode(buzzerPin, OUTPUT);

  if (!accel.begin()) {
    Serial.println("No se pudo inicializar el sensor ADXL345");
    while (1);
  }
}

void loop() {
    sensors_event_t event;
    accel.getEvent(&event);

    

    float accelX = event.acceleration.x;
    float accelY = event.acceleration.y;
    float accelZ = event.acceleration.z;

    // Calcular el ángulo de inclinación usando la aceleración en los ejes X e Z
    float inclinacion = atan2(accelX, accelZ) * 180 / PI;

    // Ajustar el umbral de detección basado en el ángulo de inclinación
    float umbral = -0 + inclinacion * 0.0; // Factor de inclinación cero para mantener el umbral constante

    // Imprimir la inclinación para fines de depuración
    Serial.print("Inclinacion: ");
    Serial.println(inclinacion);
    Serial.print("Eje Y: ");
    Serial.println(accelY);

    if (accelY < umbral) {
      long duration, distance;
      digitalWrite(trigPin, LOW);
      delayMicroseconds(2);
      digitalWrite(trigPin, HIGH);
      delayMicroseconds(10);
      digitalWrite(trigPin, LOW);
      duration = pulseIn(echoPin, HIGH);
      distance = (duration / 2) / 29.1;  // Calcular la distancia en centímetros
        // Código para activar el zumbador si hay un objeto cercano
        if (distance <= 50) {
            tone(buzzerPin, 1000); // Encender el buzzer a 1000Hz
            delay(500);            // Sonido durante 0.5 segundos
            noTone(buzzerPin);     // Apagar el buzzer
        }
    } else if (accelY > 0) {
        noTone(buzzerPin); // Detener el zumbador
    }

    delay(100); // Pequeña pausa entre lecturas
}
